// https://www.marvinj.org/en/index.html
/* eslint-disable */
function MarvinImage(t){if(t.imageData)this.imageData=t.imageData,this.width=t.imageData.width,this.height=t.imageData.height;else{if(!t.width||!t.height)throw new Error("unsupported args supplied to MarvinImage");this.imageData=new ImageData(t.width,t.height),this.width=t.width,this.height=t.height}t.colorModel?this.colorModel=t.colorModel:this.colorModel=MarvinImage.COLOR_MODEL_RGB,t.colorModel===MarvinImage.COLOR_MODEL_BINARY&&(this.arrBinaryColor=new Array(width*height))}function MarvinImageMask(t,e){this.width=t,this.height=e,this.arrMask=0!=t&&0!=e?MarvinJSUtils.createMatrix2D(width,height):null}function MarvinSegment(t,e,i,r){this.x1=t,this.x2=i,this.y1=e,this.y2=r,-1!=t&&-1!=e&&-1!=i&&-1!=r&&(this.width=i-t+1,this.height=r-e+1,this.area=this.width*this.height)}MarvinImage.COLOR_MODEL_RGB=0,MarvinImage.COLOR_MODEL_BINARY=1,MarvinImage.prototype.countColors=function(){for(var t=this.getWidth(),e=this.getHeight(),i={},r=0,n=0;n<t;n++)for(var a=0;a<e;a++){const t=this.getIntColor(n,a);i[t]||(i[t]=!0,r++)}return r},MarvinImage.prototype.clone=function(){var t=new MarvinImage({width:this.getWidth(),height:this.getHeight(),colorModel:this.colorModel});return MarvinImage.copyColorArray(this,t),t},MarvinImage.prototype.getColorModel=function(){return this.colorModel},MarvinImage.prototype.getAlphaComponent=function(t,e){var i=4*(e*this.getWidth()+t);return this.imageData.data[i+3]},MarvinImage.prototype.setAlphaComponent=function(t,e,i){var r=4*(e*this.getWidth()+t);this.imageData.data[r+3]=i},MarvinImage.prototype.getIntComponent0=function(t,e){var i=4*(e*this.getWidth()+t);return this.imageData.data[i]},MarvinImage.prototype.getIntComponent1=function(t,e){var i=4*(e*this.getWidth()+t);return this.imageData.data[i+1]},MarvinImage.prototype.getIntComponent2=function(t,e){var i=4*(e*this.getWidth()+t);return this.imageData.data[i+2]},MarvinImage.prototype.setIntColor=function(t,e,i,r,n,a){null==r?this.setIntColor1(t,e,i):null==n&&null==a?this.setIntColor2(t,e,i,r):null==a?this.setIntColor3(t,e,i,r,n):this.setIntColor4(t,e,i,r,n,a)},MarvinImage.prototype.getIntColor=function(t,e){var i=4*(e*this.getWidth()+t);return 4294967296+(this.imageData.data[i+3]<<24)+(this.imageData.data[i]<<16)+(this.imageData.data[i+1]<<8)+this.imageData.data[i+2]},MarvinImage.prototype.setIntColor1=function(t,e,i){var r=(4278190080&i)>>>24,n=(16711680&i)>>16,a=(65280&i)>>8,o=255&i;this.setIntColor4(t,e,r,n,a,o)},MarvinImage.prototype.setBinaryColor=function(t,e,i){var r=e*this.getWidth()+t;this.arrBinaryColor[r]=i},MarvinImage.prototype.getBinaryColor=function(t,e){var i=e*this.getWidth()+t;return this.arrBinaryColor[i]},MarvinImage.copyColorArray=function(t,e){if(t.getColorModel()==e.getColorModel())switch(t.getColorModel()){case MarvinImage.COLOR_MODEL_RGB:for(var i=0;i<t.imageData.data.length;i++)e.imageData.data[i]=t.imageData.data[i];break;case MarvinImage.COLOR_MODEL_BINARY:for(i=0;i<t.arrBinaryColor.length;i++)e.arrBinaryColor[i]=t.arrBinaryColor[i]}},MarvinImage.prototype.setIntColor2=function(t,e,i,r){var n=(16711680&r)>>16,a=(65280&r)>>8,o=255&r;this.setIntColor4(t,e,i,n,a,o)},MarvinImage.prototype.setIntColor3=function(t,e,i,r,n){this.setIntColor4(t,e,255,i,r,n)},MarvinImage.prototype.setIntColor4=function(t,e,i,r,n,a){var o=4*(e*this.getWidth()+t);this.imageData.data[o]=r,this.imageData.data[o+1]=n,this.imageData.data[o+2]=a,this.imageData.data[o+3]=i},MarvinImage.prototype.getWidth=function(){return this.width},MarvinImage.prototype.getHeight=function(){return this.height},MarvinImageMask.prototype.getWidth=function(){return this.width},MarvinImageMask.prototype.getHeight=function(){return this.height},MarvinImageMask.prototype.addPixel=function(t,e){this.arrMask[t][e]=!0},MarvinImageMask.prototype.removePixel=function(t,e){this.arrMask[t][e]=!1},MarvinImageMask.prototype.getMask=function(){return this.arrMask},MarvinImageMask.prototype.addRectRegion=function(t,e,i,r){for(var n=t;n<t+i;n++)for(var a=e;a<e+r;a++)this.arrMask[n][a]=!0},MarvinImageMask.createNullMask=function(){return new MarvinImageMask(0,0)},MarvinImageMask.NULL_MASK=MarvinImageMask.createNullMask();var MarvinJSUtils=new Object;function BrightnessAndContrast(){MarvinAbstractImagePlugin.super(this),this.load()}function GrayScale(){MarvinAbstractImagePlugin.super(this),this.load()}function Thresholding(){MarvinAbstractImagePlugin.super(this),this.load(),this.threshold=null,this.thresholdRange=null,this.neighborhood=null,this.range=null}MarvinJSUtils.createMatrix2D=function(t,e,i){for(var r=new Array(t),n=0;n<r.length;n++)r[n]=new Array(e),r[n].fill(i);return r},BrightnessAndContrast.prototype.load=function(){this.setAttribute("brightness",0),this.setAttribute("contrast",0)},BrightnessAndContrast.prototype.process=function(t,e,i,r,n){var a,o,s,h=this.getAttribute("brightness"),g=this.getAttribute("contrast");g=Math.pow((127+g)/127,2);for(var l=0;l<t.getWidth();l++)for(var u=0;u<t.getHeight();u++)a=t.getIntComponent0(l,u),o=t.getIntComponent1(l,u),s=t.getIntComponent2(l,u),(a+=(1-a/255)*h)<0&&(a=0),a>255&&(a=255),(o+=(1-o/255)*h)<0&&(o=0),o>255&&(o=255),(s+=(1-s/255)*h)<0&&(s=0),s>255&&(s=255),e.setIntColor(l,u,t.getAlphaComponent(l,u),Math.floor(a),Math.floor(o),Math.floor(s));for(l=0;l<t.getWidth();l++)for(u=0;u<t.getHeight();u++)a=e.getIntComponent0(l,u),o=e.getIntComponent1(l,u),s=e.getIntComponent2(l,u),a/=255,a-=.5,a*=g,a+=.5,o/=255,o-=.5,o*=g,o+=.5,s/=255,s-=.5,s*=g,s+=.5,(a*=255)<0&&(a=0),a>255&&(a=255),(o*=255)<0&&(o=0),o>255&&(o=255),(s*=255)<0&&(s=0),s>255&&(s=255),e.setIntColor(l,u,t.getAlphaComponent(l,u),Math.floor(a),Math.floor(o),Math.floor(s))},GrayScale.prototype.load=function(){},GrayScale.prototype.process=function(t,e,i,r,n){var a,o,s,h,g;null!=r&&(a=r.getMask());for(var l=0;l<t.getWidth();l++)for(var u=0;u<t.getHeight();u++)(null==a||a[l][u])&&(o=t.getIntComponent0(l,u),s=t.getIntComponent1(l,u),h=t.getIntComponent2(l,u),g=Math.ceil(.3*o+.59*s+.11*h),e.setIntColor(l,u,t.getAlphaComponent(l,u),g,g,g))},Thresholding.prototype.load=function(){this.setAttribute("threshold",125),this.setAttribute("thresholdRange",-1),this.setAttribute("neighborhood",-1),this.setAttribute("range",-1),this.pluginGray=new GrayScale},Thresholding.prototype.process=function(t,e,i,r,n){this.threshold=this.getAttribute("threshold"),this.thresholdRange=this.getAttribute("thresholdRange"),this.neighborhood=this.getAttribute("neighborhood"),this.range=this.getAttribute("range"),-1==this.thresholdRange&&(this.thresholdRange=255-threshold),this.pluginGray.process(t,e,i,r,n);var a=r.getMask();-1==this.neighborhood&&-1==this.range?this.hardThreshold(t,e,a):this.contrastThreshold(t,e)},Thresholding.prototype.hardThreshold=function(t,e,i){for(var r=0;r<t.getHeight();r++)for(var n=0;n<t.getWidth();n++)if(null==i||i[n][r]){var a=t.getIntComponent0(n,r);a<this.threshold||a>this.threshold+this.thresholdRange?e.setIntColor(n,r,t.getAlphaComponent(n,r),0,0,0):e.setIntColor(n,r,t.getAlphaComponent(n,r),255,255,255)}},Thresholding.prototype.contrastThreshold=function(t,e){this.range=1;for(var i=0;i<t.getWidth();i++)for(var r=0;r<t.getHeight();r++)checkNeighbors(i,r,neighborhood,neighborhood,t)?e.setIntColor(i,r,0,0,0):e.setIntColor(i,r,255,255,255)},Thresholding.prototype.checkNeighbors=function(t,e,i,r,n){var a,o=0;a=n.getIntComponent0(t,e);for(var s=0-i;s<=i;s++)for(var h=0-r;h<=r;h++)0==s&&0==h||a<getSafeColor(t+s,e+h,n)-range&&-1!=getSafeColor(t+s,e+h,n)&&o++;return o>i*r*.5},Thresholding.prototype.getSafeColor=function(t,e,i){return t>=0&&t<i.getWidth()&&e>=0&&e<i.getHeight()?i.getIntComponent0(t,e):-1};var MarvinAbstractImagePlugin=new Object;function FindTextRegions(){MarvinAbstractImagePlugin.super(this),this.load()}function Scale(){MarvinAbstractImagePlugin.super(this),this.load()}function MarvinAttributes(){this.hashAttributes=new Object}MarvinAbstractImagePlugin.super=function(t){t.attributes={},t.setAttribute=MarvinAbstractImagePlugin.setAttribute,t.getAttribute=MarvinAbstractImagePlugin.getAttribute},MarvinAbstractImagePlugin.setAttribute=function(t,e){this.attributes[t]=e},MarvinAbstractImagePlugin.getAttribute=function(t,e){return this.attributes[t]},FindTextRegions.prototype.load=function(){this.setAttribute("maxWhiteSpace",10),this.setAttribute("maxFontLineWidth",10),this.setAttribute("minTextWidth",30),this.setAttribute("grayScaleThreshold",127)},FindTextRegions.prototype.process=function(t,e,i,r,n){t=t.clone();var a=this.getAttribute("maxWhiteSpace"),o=this.getAttribute("maxFontLineWidth"),s=this.getAttribute("minTextWidth"),h=this.getAttribute("grayScaleThreshold");Marvin.thresholding(t,t,h);const g=t.getWidth(),l=t.getHeight();for(var u=1;u<l-1;u++)for(var M=1;M<g-1;M++){p=t.getIntColor(M,u);const e=t.getIntColor(M-1,u);p!==t.getIntColor(M-1,u)&&p!==t.getIntColor(M+1,u)&&p!==t.getIntColor(M,u-1)&&p!==t.getIntColor(M,u+1)&&t.setIntColor1(M,u,e)}for(var p,d=[],v=0;v<t.getHeight();v++)d.push([]);var c=-1,f=0,m=0,I=0;for(u=0;u<t.getHeight();u++)for(M=0;M<t.getWidth();M++){if(4294967295==(p=t.getIntColor(M,u))&&-1!=c&&(m++,I=0),4278190080==p&&(I++,-1==c&&(c=M),m=0),m>a||I>o||M==t.getWidth()-1){if(f>=s)(S=d[u]).push([c,u,c+f,u]);m=0,I=0,f=0,c=-1}-1!=c&&f++}for(u=0;u<t.getHeight()-2;u++)for(var A=d[u],b=u+1;b<=u+2;b++){var C=d[b];for(v=0;v<A.length;v++)for(var y=A[v],w=0;w<C.length;w++){var W=C[w];if(y[0]<=W[0]&&y[2]>=W[2]||y[0]>=W[0]&&y[0]<=W[2]||y[2]>=W[0]&&y[2]<=W[2]){y[0]=Math.min(y[0],W[0]),y[2]=Math.max(y[2],W[2]),y[3]=W[3],A.splice(v,1),v--,C.splice(w,1),C.push(y);break}}}var R=[];for(u=0;u<t.getHeight();u++){var S=d[u];for(var v in S){var D=S[v];R.push(new MarvinSegment(D[0],D[1],D[2],D[3]))}}i.set("matches",R)},Scale.prototype.load=function(){this.setAttribute("newWidth",0),this.setAttribute("newHeight",0)},Scale.prototype.process=function(t,e,i,r,n){if(!n){var a=t.getWidth(),o=t.getHeight(),s=this.getAttribute("newWidth"),h=this.getAttribute("newHeight");if(e.getWidth()!=s||e.getHeight()!=h)throw new Error("imageOut.width / height are not equal to newWidth / newHeight");for(var g,l,u=Math.floor((a<<16)/s),M=Math.floor((o<<16)/h),p=0;p<h;p++)for(var d=0;d<s;d++)g=Math.floor(d*u>>16),l=Math.floor(p*M>>16),e.setIntColor(d,p,t.getAlphaComponent(g,l),t.getIntColor(g,l))}},MarvinAttributes.prototype.set=function(t,e){this.hashAttributes[t]=e},MarvinAttributes.prototype.get=function(t,e){var i=this.hashAttributes[t];return null!=i?i:e},MarvinAttributes.prototype.clone=function(){var t=new MarvinAttributes;for(var e in this.hashAttributes)t.set(e,this.hashAttributes[e]);return t};var marvinLoadPluginMethods=function(t){Marvin.plugins=new Object,Marvin.plugins.brightnessAndContrast=new BrightnessAndContrast,Marvin.brightnessAndContrast=function(t,e,i,r){Marvin.plugins.brightnessAndContrast.setAttribute("brightness",i),Marvin.plugins.brightnessAndContrast.setAttribute("contrast",r),Marvin.plugins.brightnessAndContrast.process(t,e,null,MarvinImageMask.NULL_MASK,!1)},Marvin.plugins.findTextRegions=new FindTextRegions,Marvin.findTextRegions=function(t,e,i,r,n){var a=new MarvinAttributes;return Marvin.plugins.findTextRegions.setAttribute("maxWhiteSpace",Marvin.getValue(e,10)),Marvin.plugins.findTextRegions.setAttribute("maxFontLineWidth",Marvin.getValue(i,10)),Marvin.plugins.findTextRegions.setAttribute("minTextWidth",Marvin.getValue(r,30)),Marvin.plugins.findTextRegions.setAttribute("grayScaleThreshold",Marvin.getValue(n,127)),Marvin.plugins.findTextRegions.process(t,null,a,MarvinImageMask.NULL_MASK,!1),a.get("matches")},Marvin.plugins.grayScale=new GrayScale,Marvin.grayScale=function(t,e){Marvin.plugins.grayScale.process(t,e,null,MarvinImageMask.NULL_MASK,!1)},Marvin.plugins.scale=new Scale,Marvin.scale=function(t,e,i,r){if(null==r){var n=t.getHeight()/t.getWidth();r=Math.floor(n*i)}Marvin.plugins.scale.setAttribute("newWidth",i),Marvin.plugins.scale.setAttribute("newHeight",r),Marvin.plugins.scale.process(t,e,null,MarvinImageMask.NULL_MASK,!1)},Marvin.plugins.thresholding=new Thresholding,Marvin.thresholding=function(t,e,i,r){Marvin.plugins.thresholding.setAttribute("threshold",i),Marvin.plugins.thresholding.setAttribute("thresholdRange",r),Marvin.plugins.thresholding.process(t,e,null,MarvinImageMask.NULL_MASK,!1)}},Marvin=new Object;Marvin.getValue=function(t,e){return null!=t?t:e},marvinLoadPluginMethods();


// image analysis logic
const width = 300;
const height = 300;

onmessage = (message) => {
  const id = message && message.data && message.data.id || null;
  try {
    // initiate source image
    const image = new MarvinImage(
        { imageData: message.data.imageData });

    // scale down to optimize performance
    const scale = new MarvinImage(
        { width: width, height: height });
    Marvin.scale(image, scale, width, height);

    // check the colors count to filter unwanted images,
    //   take extra care not to filter out greyscale / monochrome images
    const colors = scale.countColors();
    if (colors < 5000 && !(colors >= 250 && colors <= 256)) {
      postMessage({ id, status: 'nok:not-enough-colors' });
      return;
    }

    // improve contrast so that text symbols are better visible
    const contrast = new MarvinImage(
        { width: width, height: height });
    Marvin.brightnessAndContrast(scale, contrast, 0, 3);

    // convert to grayscale for better results
    const grayscale = new MarvinImage(
        { width: width, height: height });
    Marvin.grayScale(contrast, grayscale, 180);

    // find text segments using Marvin's plugin
    const segments = Marvin
        .findTextRegions(grayscale, 30, 30, 100, 255)
        .filter(seg => seg.height > 1);
    if (segments.length > 1) {
      postMessage({ id, status: 'nok:text-detected' });
      return;
    }

    postMessage({ id, status: 'ok' });
  } catch(e) {
    console.log('image-analysis-worker: processing error')
    console.log(e);

    postMessage({ id, status: 'ok', e });
  }
};